#include "fss_read.h"
#include "../main/fss_read.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef _di_fss_read_embedded_list_process_help_
  void fss_read_embedded_list_process_help(void * const void_main) {

    if (!void_main) return;

    fss_read_embedded_list_print_message_help(&((fss_read_main_t *) void_main)->program.message);
  }
#endif // _di_fss_read_embedded_list_process_help_

#ifndef _di_fss_read_embedded_list_process_load_
  void fss_read_embedded_list_process_load(void * const void_main) {

    if (!void_main) return;

    fss_read_main_t * const main = (fss_read_main_t *) void_main;

    {
      f_state_t state = main->setting.state;
      fl_fss_data_embedded_list_t cache = macro_fl_fss_data_embedded_list_t_initialize_1(&main->cache.objects, &main->cache.positions, &main->cache.slashes);

      state.data = (void *) &cache;

      fll_fss_embedded_list_read(main->setting.buffer, &main->setting.range, &main->setting.nest, &main->setting.delimits_object, &main->setting.delimits_content, &main->setting.comments, &state);

      main->setting.state.status = state.status;
    }

    if (F_status_is_error(main->setting.state.status)) {
      fss_read_print_error_fss_read(&main->program.error, macro_fss_read_f(fll_fss_embedded_list_read));

      return;
    }

    if (main->setting.state.status == F_data_not_stop || main->setting.state.status == F_data_not_eos) {
      if (!(main->setting.flag & fss_read_main_flag_total_d)) {
        main->setting.state.status = F_status_set_warning(main->setting.state.status);

        return;
      }
    }

    main->setting.state.status = F_okay;
  }
#endif // _di_fss_read_embedded_list_process_load_

#ifdef __cplusplus
} // extern "C"
#endif
